.model flat,fastcall

include SimpleWnd.inc

WinMain    PROTO :QWORD,:QWORD,:QWORD,:QWORD

include ..\..\..\kernel32.inc
include ..\..\..\user32.inc

.data

ClassName  db "WndClass",0
AppName    db "Window",0

.code

start PROC PARMAREA=4*QWORD

LOCAL hInstance:QWORD
LOCAL CommandLine:QWORD
    
    invoke GetModuleHandle,NULL
    mov    hInstance,rax
    invoke GetCommandLine
    mov    CommandLine,rax
    invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
    invoke ExitProcess,rax

start ENDP

WinMain PROC hInst:QWORD,hPrevInst:QWORD,CmdLine:QWORD,CmdShow:QWORD PARMAREA=12*QWORD

    LOCAL wc:WNDCLASSEXA
    LOCAL msg:MSG
    LOCAL hwnd:QWORD
    LOCAL _hInst:QWORD

    mov    _hInst,rcx
    mov    wc.cbSize,SIZEOF WNDCLASSEXA
    mov    wc.style,CS_HREDRAW or CS_VREDRAW
    mov    rax,OFFSET WndProc
    mov    wc.lpfnWndProc,rax

    xor    rax,rax
    mov    wc.cbClsExtra,eax
    mov    wc.cbWndExtra,eax
    mov    wc.hInstance,rcx
    mov    wc.hbrBackground,COLOR_WINDOW+1
    mov    wc.lpszMenuName,rax

    mov    rax,OFFSET ClassName
    mov    wc.lpszClassName,rax
    invoke LoadIcon,NULL,IDI_APPLICATION
    mov    wc.hIcon,rax
    mov    wc.hIconSm,rax
    invoke LoadCursor,NULL,IDC_ARROW
    mov    wc.hCursor,rax
    invoke RegisterClassEx,ADDR wc

    invoke CreateWindowEx,0,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,\
           _hInst,0
    mov    hwnd,rax

    invoke ShowWindow,hwnd,SW_SHOWNORMAL
    invoke UpdateWindow,hwnd

    .WHILE (1)
        invoke GetMessage,ADDR msg,NULL,0,0
        .break .if (!rax)
        invoke TranslateMessage,ADDR msg
        invoke DispatchMessage,ADDR msg
    .ENDW

    mov   rax,msg.wParam
    ret

WinMain ENDP

WndProc PROC hWnd:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD PARMAREA=4*QWORD

    .IF edx == WM_DESTROY
        invoke PostQuitMessage,NULL

    .ELSE
        invoke DefWindowProc,rcx,rdx,r8,r9
        ret

    .ENDIF

    xor rax,rax
    ret

WndProc ENDP

END start
